<?php

namespace Pinpoint\DeliveryDate\Controller\Estimation;

use Magento\Framework\App\Action\Action;
use Magento\Framework\View\Result\PageFactory;
use Magento\Framework\App\Action\Context;
use Pinpoint\DeliveryDate\Model\EstimatedDate;

/**
 * Class CheckDate
 * @package Pinpoint\DeliveryDate\Controller\Estimation
 */
class CheckDate extends Action
{
    /**
     * @var \Magento\Framework\Controller\Result\JsonFactory
     */
    protected $resultJsonFactory;

    /**
     * @var \Magento\Store\Model\StoreManagerInterface
     */
    protected $storeManager;

    /**
     * @var EstimatedDate
     */
    protected $estimatedDate;

    /**
     * CheckDate constructor.
     * @param Context $context
     * @param \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory
     * @param EstimatedDate $estimatedDate
     * @param \Magento\Store\Model\StoreManagerInterface $storeManager
     */
    public function __construct(
        Context $context,
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \Pinpoint\DeliveryDate\Model\EstimatedDate $estimatedDate,
        \Magento\Store\Model\StoreManagerInterface $storeManager
    ) {
        parent::__construct($context);
        $this->resultJsonFactory = $resultJsonFactory;
        $this->storeManager = $storeManager;
        $this->estimatedDate = $estimatedDate;
    }

    /**
     * @return \Magento\Framework\Controller\Result\Json
     */
    public function execute()
    {
        $resultPage = $this->resultJsonFactory->create();
        $currentStore = $this->storeManager->getStore()->getId();

        $estimatedDate = $this->estimatedDate->getDateByShippingCode($this->getRequest()->getParam('shipping_method'), $currentStore);

        return $resultPage->setData(['estimation' => $estimatedDate]);
    }
}